{****************************************************************
*  ᭮ ணࠬ, ᮤঠ 				*
*	-  ६					*
*	-  ⠭					*
*	- ⠡ 맮 ࠡ稪 뢠		*
****************************************************************}

.MODULE                 main_program;

{  ॣ஢, ⮡ࠦ     ADSP-21XX	}
.const  Sys_Ctrl_Reg=               0x3fff;
.const  Dm_Wait_Reg=                0x3ffe;
.const  Tperiod_Reg=                0x3ffd;
.const  Tcount_Reg=                 0x3ffc;
.const  Tscale_Reg=                 0x3ffb;
.const  Sport1_Ctrl_Reg=            0x3ff2;
.const  Sport1_Sclkdiv=             0x3ff1;
.const  Sport1_Rfsdiv=              0x3ff0;
.const  Sport1_Autobuf_Ctrl=        0x3fef;

{ ⠭  LBios							}
.const  DsLoadLength=	    512;{  ᥣ 		}
.const  FIFOSIZE=         320;{ ࢮ砫 ࠧ FIFO }

{ ********************************************************************  }
{  ⮢ 					  	}
{ ********************************************************************  }
.const PCI		=0x3400;	{  			}
.const TTL_DSP_OUT	=0x3404;	{ 뢮  4 ஢ 	}
.const AD_START		=0x3401;	{   			}
.const INPUT_CTRL	=0x3401;	{   		}
.const AD_DATA		=0x3402;	{   			}
.const MEMORY_SEGMENT	=0x3403;	{ ⠭  ࠭ }
.const TTL_DSP_IN	=0x3403;	{  ⮢  ஢ }
.const DA_OUT    	=0x3403;	{ 뢮  ॣ 		}
.const DA1    		=0x3403;	{   ॣ   }
.const DA2	    	=0x3403;	{   ॣ  ன }
.const INTERRUPT	=0x3402;	{ ஢ 뢠 IRQ	}

{ ࠬ ᨢ, ।饣 ६ প  ࠧ ⨯	}
{  ஢ (ADSP-2105, ADSP-2115)					}
.const DELAY_SIZE =5;         { ࠧ ᨢ    }
.const DELAY_CHANNEL_SET=0;		{ প ⠭ 	}
.const DELAY_CONVERSION =1;		{ প ⠭ 	}
.const DELAY_SOFT =2;         { 쭠 প       }
.const DELAY_FILTER =3;       { ⠭   䨫}
.const DELAY_WAIT_STATE =4;		{ প    ॣ }

{ ********************************************************************  }
{   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  }
{ ********************************************************************  }

.VAR/SEG=int_dm/DM/RAM/CIRC BFifo[FifoSize];  	{  FIFO 		}
.VAR/SEG=int_dm/DM/RAM{/CIRC} SoftChannel[32];    { ᨢ  ࠬ  }
.VAR/SEG=int_dm/DM/RAM FReceiveHandler;		{  ࠡ稪 SPORT   }
.VAR/SEG=int_dm/DM/RAM RateValue;		{ ࢠ ⠩	}
.VAR/SEG=int_dm/DM/RAM NChannel;		{ ᫮ 		}
.VAR/SEG=int_dm/DM/RAM FirstDa;     {      }
.VAR/SEG=int_dm/DM/RAM FMainArray[36];		{  ०	}
.VAR/SEG=int_dm/DM/RAM FReceiveArray[36];	{  ࠡ稪 SPORT }
.VAR/SEG=int_dm/DM/RAM FTimerArray[36];		{  ࠡ稪 Timer }

{ ६  ࠭ ॣ஢					}
.VAR/SEG=int_dm/DM/RAM OldSr0;
.VAR/SEG=int_dm/DM/RAM OldSr1;
.VAR/SEG=int_dm/DM/RAM OldAx0;
.VAR/SEG=int_dm/DM/RAM OldAy0;
.VAR/SEG=int_dm/DM/RAM OldAr;

.VAR/SEG=int_dm/DM/RAM UxOn;            { 䫠 祭 		}
.VAR/SEG=int_dm/DM/RAM ScaleValue;	{ ⠡ 樥	}
.VAR/SEG=int_dm/DM/RAM SynchroMode; { ० ᨭ஭樨   }
.VAR/SEG=int_dm/DM/RAM TtlSynchroWait;  { ⨯  ᨭ஭樨   }
.VAR/SEG=int_dm/DM/RAM SynchroAdChannel;{    ᨭ஭樨}
.VAR/SEG=int_dm/DM/RAM SynchroAdValue;	{ ண 祭  	}
.VAR/SEG=int_dm/DM/RAM SynchroTtlMask;  { ᪠ ᨭ஭樨   }
.VAR/SEG=int_dm/DM/RAM DaCont;    { ० ६ 뢮  }
.VAR/SEG=int_dm/DM/RAM DaCurrent; { 䨧᪨  ⥪饣 }
.VAR/SEG=int_dm/DM/RAM UvxNChannels;	{ ᫮   		}
                             {  }
.VAR/SEG=int_dm/DM/RAM WaitDataState; { প        }
.VAR/SEG=int_dm/DM/RAM FifoStartAddress; { 砫  FIFO    }
.VAR/SEG=int_dm/DM/RAM FifoLength;	{  FIFO			}
.VAR/SEG=int_dm/DM/RAM Fifo1Length; {  ࢮ  FIFO      }
.VAR/SEG=int_dm/DM/RAM Fifo2Length; {  ன  FIFO      }
.VAR/SEG=int_dm/DM/RAM FifoType;    { ⨯ FIFO : 0-७, 1-譨    }

{ ᨢ  ६묨, 騬  ⨯  (  ᪮)	}
.VAR/SEG=int_dm/DM/RAM DelayArray[DELAY_SIZE];
.VAR/SEG=int_dm/DM/RAM ADSP100[DELAY_SIZE];

{ ६ ஢ 䨫樨					}
.VAR/SEG=int_dm/DM/RAM XPtr;
.VAR/SEG=int_dm/DM/RAM KeyRes;

{  320(FIFO)+177(६)=497 ᫮  512-}

{ ********************************************************************  }
{    (  ) !!!!!!!!!!!!!!!!!!!!!!! }
{ ********************************************************************  }


{ ********************************************************************  }
{    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  }
{ ********************************************************************  }

  { ࠡ⪠ RESET,     ࠧ ᫥ 㧪 ணࠬ }
	JUMP Start; 		{ 室  ணࠬ 樠樨	}
	NOP;
	NOP;
   RF:  RTI;

      {  ࠡ稪 뢠 IRQ 2 ( ஬  	}
      {     ) 						}
        DIS SEC_REG;      { ३    ॣ஢ }
        DM(OldAx0)=AX0;		{ ࠭  ॣ஢		}
        DM(OldAy0)=AY0;
        DM(OldAr)=AR;
        AY0=DM(PCI);   		{ ⠥ ᫮  PC			}
        AX0=0x300;        { ᬮਬ,  뢮     }
        AR=AX0 AND AY0;
	IF EQ JUMP SetNewMode;	{ ᫨    室   ०	}
        CALL DaFon;       {   䮭 뢮      }
        AX0=DM(OldAx0);		{ ⠭ ॣ			}
        AY0=DM(OldAy0);
        AR=DM(OldAr);

  { 뢠  ।饣 ਠ쭮 ,  ᯮ	}
	RTI;
	NOP;
	NOP;
	NOP;

  {    뢠    (SPORT Receive) 				}
  {     ਠ ⮬, ᯮ  ⢥ ନ஢⥫}
  {    쭮 প						}
        ENA SEC_REG;    { ३  ன  ॣ஢   }
        DM(Sys_Ctrl_Reg)=MR0;	{ 몫稬 SPORT			}
        I4=DM(FReceiveHandler); { 쬥  ࠡ稪     }
        JUMP (I4);               { ३  ࠡ稪   }

  {    뢠  ⠩ 			}
        JUMP (I7);		{ ࠡ稪 ࠭  ॣ I7	}
        NOP;
        NOP;
        NOP;

{ ********************************************************************  }
{     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  }
{ ********************************************************************  }


  { ********************************************************************}
  {    ணࠬ  ⥪⮬ ࠩ     				}
  { ********************************************************************}

.INCLUDE <MACRO.H>;	{ । ம।			}
.INCLUDE <LOADDSL.H>;	{ 砫쭠 㧪 ᥣ 		}
.INCLUDE <START.H>;	{ 樠 ᫥ 㧪			}
.INCLUDE <SWITCH.H>;	{ ࠡ稪 뢠  		}
.INCLUDE <ADCHAN.H>;	{  				}
.INCLUDE <OUTDA.H>;	{ 뢮  					}
.INCLUDE <STREAM.H>;	{  				}
.INCLUDE <FIFO.H>;	{ ࠡ  FIFO ஬				}
.INCLUDE <SOFT.H>;	{    FIFO			}
.INCLUDE <TTL.H>;	{ ࠢ ஢묨 ﬨ			}
.INCLUDE <IRQ.H>;	{   뢠				}
.INCLUDE <SUBR.H>;	{ ᯮ⥫ ணࠬ			}
.INCLUDE <MEMORY.H>;	{ ஢ઠ 譥 			}
.INCLUDE <SYNCHRO.H>;	{ ᨭ஭    			}
.ENDMOD;
